;IR RC5  
;  
;lva()kft3,tgc5,ru
;RC5 IR Transmiter.asm
;********************************************************************
;*
;*    AVR415.asm  Atmel http://www.atmel.com
;*
;*   : , , ,   ..  
;*          
;*
;********************************************************************
.include "tn28def.inc"
.include "RC5 IR Code.asm"
;********************************************************************
;*
;* 
;*
;********************************************************************
.equ	pulses		= 256 - 32		; 256 -    
.equ	numberofbits	= 30		; 2 *     + 1 (14+1)*2=30
;-----------------------------------
.equ	invPA2ovf	= (1<<3) | 2	; IR 
.equ	activePA2ovf	= (2<<3) | 2; IR  ="0"+
.equ	inactivePA2ovf	= (3<<3) | 2; IR  ="1"
;-----------------------------------
.equ	noMOD		= 0				;MODCR  
.equ	F38KHz_D25	= (2<<3) | 3	;MODCR   38KHz,  25%
.equ	F38KHz_D33	= (3<<3) | 2	;MODCR   38KHz,  33%
.equ	F38KHz_D50	= (5<<3) | 1	;MODCR   38KHz,  50%
.equ	F38KHz_D67	= (3<<3) | 4	;MODCR   38KHz,  67%
.equ	F38KHz_D75	= (2<<3) | 5	;MODCR   38KHz,  75%
;-----------------------------------	
.equ	FAULT		= 0xFF
.equ	IND1		= 0				;   A -0
.equ	IND2		= 1				;   A -1
;********************************************************************
;*
;*  
;*
;********************************************************************
.def	command		= R20		;, LSB  ()
.def	adress		= R21		;, MSB  ()
.def	select		= R22		;  

.def	zero		= R2		;=0   zero
.def	allhigh		= R27		;=1   0xFF

.def	temp		= R16		; 
.def	toggle		= R3		;    
.def	toggle_mask	= R17		;    

.def	row_scan 	= R18		;  
.def	row_saved	= R4		;  
.def	col_scan 	= R19		;  
.def	col_saved	= R5		;  

.def	ptr			= R23		;     
.def	old_ptr		= R24		;    (    )
.def	keys		= R25		;    ,    =0

.def	bitnumb		= R26		;      ? 
;********************************************************************
;*
;*  
;*
;********************************************************************
;.cseg
.org	0x0000
	rjmp	reset				; 
.org	LLINTaddr
	rjmp	send				;   -
.org 	OVF0addr
	rjmp	bitfinished			;  ()
.org INT_VECTORS_SIZE			; 
;***   **************************************************
;*
;*   
;*
;********************************************************************
reset:
;***        ..	
;	ldi    r16,0x5F+3*2    			;    
;	out  0x3d,r16
;---------------------------------------------------
	clr	zero				; "zero" 
	ser	allhigh				; "allhigh" 
    clr bitnumb			    ;  
	clr select			    ;  
	out	DDRD,allhigh       	;  D  
	out	PACR,allhigh		; ,  
	sbi	PACR,PA2HC			; ( )
	sbi ICR,TOIE0			;.   
	ldi	temp,F38KHz_D25		;  
	out	MODCR,temp
	ldi	toggle_mask, 0b00100000; 5   
;***   **************************************************
;*
;*     
;*
;********************************************************************
main_loop:
    cli                      ; -
    tst  bitnumb             ;  
    breq Pwdn_mode           ;  
    ldi  temp,(1<<PLUPB)|(1<<SE);. IDLE mode
    rjmp pwdn_enable         ;  IDLE mode
Pwdn_mode:
    sbi  ICR,LLIE            ;.   -   
    ldi  temp,(1<<PLUPB)|(1<<SE)|(1<<SM);. PowerDown mode
pwdn_enable:
    out  MCUCS,temp
    sei                      ;. -
    sleep                    ; 
    rjmp main_loop           ;
;********************************************************************
;*
;*           
;*
;********************************************************************
key_pressed:
	mov	col_saved,col_scan	;  
	mov	row_saved,row_scan	;  
cont_row_scan:
	sbrc	row_scan,0		; 0 = 0, 
	dec	keys				;-1   "1"  0,    -7
	lsr	row_scan			;     
	brne	cont_row_scan	;      
	rjmp	ret_key_pressed
;***   **************************************
;*
;*     ( ,  )
;*
;********************************************************************
send:
    cbi ICR,LLIE       ;     
;***   **************************************************
;*
;*        
;* R1:R0  .
;*
;*   : temp, row_scan, col_scan
;*   : C
;*
;* :  
;*                R1                        R0
;*
;*       St St T0 S4 S3 S2 S1 S0 - C5 C4 C3 C2 C1 C0 x1 x0
;*       ----- -- --------------   ----------------- -----
;*         |   |  |    |         |
;*         |   |
;*         |   +-    
;*         +-----  
;*
;********************************************************************
	ldi	keys,47				; , (8*6-1) =0
	ldi	col_scan,0b00000100	;   
cont_col_scan:
	out	DDRD,col_scan		;    ,  
	out	PORTD,zero			; "0"  ,      
	nop	nop	nop	nop	nop
	in	row_scan,PINB		;    
	ori	row_scan,0b00000011	;2  
	cpi	row_scan,0xff		;   ?
	brne	key_pressed		; ,    
	subi	keys,8			;   ,    8
ret_key_pressed:
	out	PORTD,allhigh		;    "1"
	out	DDRD,allhigh
	lsl	col_scan			;    
	brcc	cont_col_scan	;   ,  
							; ,   
;--------------------------------------------------------------
	ldi	ptr,fault			;  .
	tst	keys				;,         .
	brne	ch_end1			;       
fl2:
	inc	ptr					;+1,  
	lsr	row_saved			;   1
	brcs	fl2				; ptr   
							;  
fl3:
	sbrc	col_saved,0		; .  =1   
	rjmp	fcont
	subi	ptr, -8			;   ,  8
	lsr	col_saved			;  
	rjmp	fl3				;   8 
ch_end1:
	rjmp	ch_end
fcont:
;----- ptr   -----
	ldi	ZL,low(Point_code*2);    	
	ldi	ZH,high(Point_code*2)
	add	ZL,ptr
	adc	ZH,zero
	lpm						;  ptr
	mov ptr,r0
;-----  -----
	tst	select
	brne	sel_list2
	ldi	ZL,low(CD_player*2)	;    
	ldi	ZH,high(CD_player*2)
	rjmp	sel_list
sel_list2:
	cpi	select,1
	brne	sel_list3
	ldi	ZL,low(TV_video*2)
	ldi	ZH,high(TV_video*2)
	rjmp	sel_list
sel_list3:
	ldi	ZL,low(VCR_video*2)
	ldi	ZH,high(VCR_video*2)
sel_list:
	lsl	ptr					;   / (*2)
	add	ZL,ptr				;      
	adc	ZH,zero
	lpm						;   
	mov	adress,r0			; 
	inc	ZL					;     
	lpm						;   
	mov	command,r0			; 
;----- ,   -----
	cp	adress,allhigh		;0xFF?
	breq	ch_end			; 
	cpi	adress,0xAA			;0xAA?
	brne	prepare_pack	;   
;-----     -----
	inc	select				;+1
	cpi select,0b00000011
	brne	select_key
	clr	select
	sbi	PORTA,IND1			;  
	rjmp	select_key2
select_key:
	sbrs	select,0		;  0
	sbi	PORTA,IND1			; "0",   
	sbi	PORTA,IND2			; "1",  
select_key2:
	out	DDRD,allhigh		; D 
	out	PORTD,zero			; = "0"
	nop	nop	nop	nop	nop	nop	nop	nop	nop	nop
	in	row_scan,PINB		;    
	ori	row_scan,0b00000011	;2  
	cpi	row_scan,0xff		;   ?
	brne	select_key2		; 
	cbi	PORTA,IND1			; 
	cbi	PORTA,IND2
	rjmp	ch_end			;
prepare_pack:
;-----  "1", 2   (-) +0xC0-----
	ori	adress,0b11000000
;-----   2 ,    -----
	lsl	command
	lsl	command
;-----  "1", 2   +0x03-----
	ori	command,0b00000011
;-----  -----
	cp	old_ptr,ptr			;   ?
	breq	same_ptr		;      
	eor	toggle,toggle_mask	;  
same_ptr:
	bst	toggle,5			;   T-
	bld	adress,5			;       T-
;********************************************************************
;*
;*    
;*  14 ,  1      =1
;*
;********************************************************************
;----- -----
	ldi	temp,inactivePA2ovf	;=1,  
	out	TCCR0,temp			; IR-
	ldi	bitnumb,numberofbits;=30,   -  
ch_end:
	out	DDRD,allhigh		; D 
	out	PORTD,zero			; = "0"
	mov	old_ptr,ptr			; ptr ,
    ret                     ;  ? reti
;***  *******************************************************
;*
;*           
;*
;********************************************************************
bitfinished:
	dec	bitnumb				; 
	breq	finished		;    ,  
;-----    -----
	mov	temp,select
	inc	temp
	sbrc	temp,0
	sbi	PORTA,IND1		    ;"1",     
	sbrc	temp,1
	sbi	PORTA,IND2		    ;"1",     
	ldi	temp,pulses			;=0xE0,  , 38, 32=0,84 
	out	TCNT0,temp			;  34 =0,89
;-----    -----
	sbrc	bitnumb,0		;      ?
	rjmp	firsthalf
	ldi	temp,invPA2ovf		;  ,  PA2 
	rjmp	intfin
finished:
;-----  -----
	cbi	PORTA,IND1		    ;"0",  , . 
	cbi	PORTA,IND2
	sbic	TCCR0,CS02		;2 (Clock Select),    ?
	rjmp	end_longwait	; ,    
	ldi	bitnumb,1			;     
							;    "finished:"
;-----110  ,  89 (39,5)~40,  207  216-----
	ldi	temp,207			;110, 207=0xCF=49,   1024*49=50176 
	out	TCNT0,temp			;  
							;  3456 ,    50176+3456=53632  
							; ,  117.9?
	ldi	temp,5				;101,     CK/1024
							; 010,   38
	rjmp	intfin			
end_longwait:
	out	TCCR0,zero			;      
	in	temp,PINB			;   
							;    
	cpi	temp,0xFF		
	brne	NotSetFault		;  ,  
	ldi	old_ptr,fault		;   ,    
							;    
NotSetFault:
	ret						;  ,  
firsthalf:
	lsl	command				;  
	rol	adress
	brcc	outlow			;  ?
	ldi	temp,inactivePA2ovf	;=1, ,     
	rjmp	intfin
outlow:
	ldi	temp,activePA2ovf	;=0, ,    IR 
intfin:
	out	TCCR0,temp			;  /   
	ret						;  -,   
.exit
